VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "GCode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Public g As New Collection
Public x As String
Public y As String
Public Raw As String
Public lineNo As String
Public i As String
Public J As String
Public f As String
Public Z As String
Public Other As String
Public Edited As Boolean 'this is up to you to manually set if you edit it!

Public Enum Keys
    kX
    ky
    kZ
    kI
    kj
    kF
End Enum

Function Recompose() As String
    
    Dim v As String
    Dim u
    
    If Len(lineNo) > 0 Then
        v = "N" & lineNo
    End If
    
    If g.Count > 0 Then
        For Each u In g
            v = v & "G" & u
        Next
    End If
    
    If isSet(kX) Then v = v & "X" & x
    If isSet(ky) Then v = v & "Y" & y
    If isSet(kZ) Then v = v & "Z" & Z
    If isSet(kI) Then v = v & "I" & i
    If isSet(kj) Then v = v & "J" & J
    If isSet(kF) Then v = v & "F" & f
    v = v & Other
    
    Recompose = v
    
    
End Function

Public Function Contains_GCode(t) As Boolean
    
    For Each w In g
        If w = t Then
            Contains_GCode = True
            Exit Function
        End If
        If Len(t) = 1 Then
            If w = "0" & t Then
                Contains_GCode = True
                Exit Function
            End If
        End If
    Next
    
End Function

Public Function isZOnly() As Boolean
    
    If Not isSet(kZ) Then Exit Function
    
    isZOnly = True
    If isSet(kX) Then isZOnly = False
    If isSet(ky) Then isZOnly = False
    If isSet(kI) Then isZOnly = False
    If isSet(kj) Then isZOnly = False
        
End Function

Public Function isSet(k As Keys) As Boolean
    Dim v
    
    Select Case k
        Case kX: v = x
        Case ky: v = y
        Case kZ: v = Z
        Case kI: v = i
        Case kj: v = J
        Case kF: v = f
    End Select
    
    isSet = IIf(Len(v) > 0, True, False)
    
End Function
    
Public Function Contains(k As Keys, vv As String) As Boolean
Dim v
    
    Select Case k
        Case kX: v = x
        Case ky: v = y
        Case kZ: v = Z
        Case kI: v = i
        Case kj: v = J
        Case kF: v = f
    End Select
    
    If InStr(1, v, vv, vbTextCompare) > 0 Then
        Contains = True
    End If

End Function

    

Sub LoadLine(ByVal N)
    
    Raw = N
    
    'N = UCase(N)
    v = "X.Y.I.J.F.G.Z.M.T.S.H"
    v = Split(v, ".")
    
    For Each p In v
        N = Replace(N, p, " " & p)
    Next
    
    N = Replace(N, "  ", " ")
    
    q = Split(N, " ")
    For Each c In q
        c = Trim(c)
        If Len(c) > 0 Then
            Select Case Left(c, 1)
                Case "X": x = Mid(c, 2)
                Case "Y": y = Mid(c, 2)
                Case "I": i = Mid(c, 2)
                Case "J": J = Mid(c, 2)
                Case "F": f = Mid(c, 2)
                Case "G": g.Add Mid(c, 2)
                Case "N": lineNo = Mid(c, 2)
                Case "Z": Z = Mid(c, 2)
                Case Else: Other = Other & c
            End Select
        End If
    Next
    
End Sub
